//////////////////////////////////////////////////////////////////////////// 
// 
// Copyright (C) DSTC Pty Ltd (ACN 052 372 577) 1993, 1994, 1995.
// Unpublished work.  All Rights Reserved.
// 
// The software contained on this media is the property of the
// DSTC Pty Ltd.  Use of this software is strictly in accordance
// with the license agreement in the accompanying LICENSE.DOC 
// file. If your distribution of this software does not contain 
// a LICENSE.DOC file then you have no rights to use this 
// software in any manner and should contact DSTC at the address 
// below to determine an appropriate licensing arrangement.
// 
//      DSTC Pty Ltd
//      Level 7, GP South
//      University of Queensland
//      St Lucia, 4072
//      Australia
//      Tel: +61 7 3365 4310
//      Fax: +61 7 3365 4311
//      Email: jcsi@dstc.qut.edu.au
// 
// This software is being provided "AS IS" without warranty of
// any kind.  In no event shall DSTC Pty Ltd be liable for
// damage of any kind arising out of or in connection with
// the use or performance of this software.
// 
//////////////////////////////////////////////////////////////////////////// 

package com.dstc.security.kerberos.creds;

import java.util.Vector;
import java.util.Iterator;
import java.util.Hashtable;
import java.util.Enumeration;
import java.io.*;

/**
 * An in-memory implementation of CredentialStore
 *
 * @author Ming Yung
 */
class MemoryCredentialStore extends CredentialStore
{
  protected CredentialName client;
  protected Hashtable creds;
  private String defaultUser;

  MemoryCredentialStore()
  {
    creds = new Hashtable();
    this.defaultUser = ctx.getUsername();
  }

  public void put(Credential cred)
  {
    creds.put(cred.getServiceName(), cred);
  }

  public Iterator getCredentials()
  {
    return creds.values().iterator();
  }

  public String getStoreType()
  {
    return "Memory";
  }

  /**
   * Returns the Credential for the supplied service name
   */
  public Credential getCredential(String serviceName)
  {
    return (Credential)creds.get(serviceName);
  }

  public String getDefaultUser()
  {
    return this.defaultUser;
  }
}
